Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 67811)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 67815)
@@ -257,4 +257,5 @@
         <file alias="os_l4.png">images/os_l4.png</file>
         <file alias="os_linux.png">images/os_linux.png</file>
+        <file alias="os_linux_64.png">images/os_linux_64.png</file>
         <file alias="os_linux22.png">images/os_linux22.png</file>
         <file alias="os_linux24.png">images/os_linux24.png</file>
@@ -262,5 +263,4 @@
         <file alias="os_linux26.png">images/os_linux26.png</file>
         <file alias="os_linux26_64.png">images/os_linux26_64.png</file>
-        <file alias="os_linux_other.png">images/os_linux_other.png</file>
         <file alias="os_macosx.png">images/os_macosx.png</file>
         <file alias="os_macosx_64.png">images/os_macosx_64.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_hidpi.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_hidpi.qrc	(revision 67811)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_hidpi.qrc	(revision 67815)
@@ -250,5 +250,4 @@
         <file alias="os_freebsd_64_hidpi.png">images/hidpi/os_freebsd_64_hidpi.png</file>
         <file alias="os_freebsd_hidpi.png">images/hidpi/os_freebsd_hidpi.png</file>
-        <file alias="os_freedos_hidpi.png">images/hidpi/os_freedos_hidpi.png</file>
         <file alias="os_gentoo_64_hidpi.png">images/hidpi/os_gentoo_64_hidpi.png</file>
         <file alias="os_gentoo_hidpi.png">images/hidpi/os_gentoo_hidpi.png</file>
@@ -261,11 +260,9 @@
         <file alias="os_linux26_hidpi.png">images/hidpi/os_linux26_hidpi.png</file>
         <file alias="os_linux_hidpi.png">images/hidpi/os_linux_hidpi.png</file>
-        <file alias="os_linux_other_hidpi.png">images/hidpi/os_linux_other_hidpi.png</file>
+        <file alias="os_linux_64_hidpi.png">images/hidpi/os_linux_64_hidpi.png</file>
         <file alias="os_macosx_64_hidpi.png">images/hidpi/os_macosx_64_hidpi.png</file>
         <file alias="os_macosx_hidpi.png">images/hidpi/os_macosx_hidpi.png</file>
         <file alias="os_mandriva_64_hidpi.png">images/hidpi/os_mandriva_64_hidpi.png</file>
         <file alias="os_mandriva_hidpi.png">images/hidpi/os_mandriva_hidpi.png</file>
-        <file alias="os_mint_64_hidpi.png">images/hidpi/os_mint_64_hidpi.png</file>
-        <file alias="os_mint_hidpi.png">images/hidpi/os_mint_hidpi.png</file>
         <file alias="os_netbsd_64_hidpi.png">images/hidpi/os_netbsd_64_hidpi.png</file>
         <file alias="os_netbsd_hidpi.png">images/hidpi/os_netbsd_hidpi.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 67811)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 67815)
@@ -20,4 +20,5 @@
         <file alias="os_win98.png">images/os_win98.png</file>
         <file alias="os_win_other.png">images/os_win_other.png</file>
+        <file alias="os_win_other_64.png">images/os_win_other_64.png</file>
         <file alias="os_winme.png">images/os_winme.png</file>
         <file alias="os_winnt4.png">images/os_winnt4.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_hidpi.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_hidpi.qrc	(revision 67811)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_hidpi.qrc	(revision 67815)
@@ -29,4 +29,5 @@
         <file alias="os_win98_hidpi.png">images/hidpi/os_win98_hidpi.png</file>
         <file alias="os_win_other_hidpi.png">images/hidpi/os_win_other_hidpi.png</file>
+        <file alias="os_win_other_64_hidpi.png">images/hidpi/os_win_other_64_hidpi.png</file>
         <file alias="os_winme_hidpi.png">images/hidpi/os_winme_hidpi.png</file>
         <file alias="os_winnt4_hidpi.png">images/hidpi/os_winnt4_hidpi.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIIconPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIIconPool.cpp	(revision 67811)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIIconPool.cpp	(revision 67815)
@@ -300,5 +300,5 @@
     m_guestOSTypeIconNames.insert("Windows2016_64",  ":/os_win2k16_64.png");
     m_guestOSTypeIconNames.insert("WindowsNT",       ":/os_win_other.png");
-    m_guestOSTypeIconNames.insert("WindowsNT_64",    ":/os_win_other.png"); /// @todo os_win_other_64
+    m_guestOSTypeIconNames.insert("WindowsNT_64",    ":/os_win_other_64.png");
     m_guestOSTypeIconNames.insert("OS2Warp3",        ":/os_os2warp3.png");
     m_guestOSTypeIconNames.insert("OS2Warp4",        ":/os_os2warp4.png");
@@ -334,6 +334,6 @@
     m_guestOSTypeIconNames.insert("Oracle",          ":/os_oracle.png");
     m_guestOSTypeIconNames.insert("Oracle_64",       ":/os_oracle_64.png");
-    m_guestOSTypeIconNames.insert("Linux",           ":/os_linux_other.png");
-    m_guestOSTypeIconNames.insert("Linux_64",        ":/os_linux_other.png"); /// @todo os_linux_other_64
+    m_guestOSTypeIconNames.insert("Linux",           ":/os_linux.png");
+    m_guestOSTypeIconNames.insert("Linux_64",        ":/os_linux_64.png");
     m_guestOSTypeIconNames.insert("FreeBSD",         ":/os_freebsd.png");
     m_guestOSTypeIconNames.insert("FreeBSD_64",      ":/os_freebsd_64.png");